--drop schema TRAFODION.mysch cascade;
--control query default DDL_DEFAULT_LOCATIONS '';
--CONTROL QUERY DEFAULT AUTOMATIC_RECOMPILATION 'ON';
--Control Query Default POS 'off';
--showcontrol default DDL_DEFAULT_LOCATIONS;
create schema TRAFODION.mysch;
set schema TRAFODION.mysch;

drop table T1; 
drop table T2; 
drop table T3; 
drop table T7; 
drop table T8; 
drop table T9;
drop table T4; 
drop table T5; 
drop table T6;

Create table  T1(A int  not null not droppable primary key, 
                           B  smallint default null) 
                   attribute extent 256;

Create table T2(C int default null, 
                            D smallint not null not droppable primary key, 
                            E largeint default null) 
                            attribute extent 256;

Create  table T3(F int default null,  
                           G  smallint default null, 
                           H largeint not null not droppable primary key, 
                            I numeric(9,3) default null) 
                            attribute extent 256;

Create  table T4(J int default null,  
                           K smallint default null, 
                            L largeint default  null ,  
                             M numeric(9,3) not null not droppable primary key,  
                             N decimal(18,9) default null) 
                             attribute extent 256;

Create  table T5(      O int default null,  
                        P smallint default null, 
			Q  largeint default null, 
			R numeric(9,3) not null not droppable,  
			S decimal(18,9) default null, 
			T char(20) default null, 
			U float(52) default null, 
			V real default null, 
			W double precision default null, 
			X timestamp default null, 
			Y interval year to month default null ,
			Z char (12) default null, 
			AA time not null not droppable, primary key(R,AA))
 			attribute extent 256;

Create  table T6       (O int default null,  
                  	 P smallint default null, 
			Q  largeint default null, 
			R numeric(9,3) not null ,  
			S decimal(18,9) default null, 
			T char(20) default null, 
			U float(52) default null, 
			V real default null, 
			W double precision default null, 
			X timestamp default null, 
			Y interval year to month default null ,
			Z char (12) default null, 
			AA time not null primary key droppable)
                        attribute extent 256 no partitions;

create index smint_idx on T1(B) attribute extent 256;
create index lint_idx on T2(E) attribute extent 256;
create index int_idx on T2(C) attribute extent 256;
create index num_idx on T3(I) attribute extent 256;
create index lint_idxT3 on T3(G) attribute extent 256;
create index int_idxT3 on T3(F) attribute extent 256;
create index  dem_idxT4 on T4(N) attribute extent 256;
create index  int_idxT4 on T4(J) attribute extent 256;
create index  sint_idxT4 on T4(K) attribute extent 256;
create index  lint_idxT4 on T4(L) attribute extent 256;
create unique index dat_idxT5 on  T5(T) attribute extent 256;
create index  int_idxT5 on T5(O) attribute extent 256;
create index  smint_idxT5 on T5(P) attribute extent 256;
create index  lint_idxT5 on T5(Q) attribute extent 256;
create index  dem_idxT5 on T5(S) attribute extent 256;
create index  flo_idxT5 on T5(U) attribute extent 256;
create index   rel_idxT5 on T5(V) attribute extent 256;
create index  dou_idxT5 on T5(W) attribute extent 256;
create unique index   tms_idxT5 on T5(X) attribute extent 256;
create index  intv_idxT5 on T5(Y) attribute extent 256;
create index   char_idxT5 on T5(Z) attribute extent 256;
create unique index dat_idxT6 on  T6(T) attribute extent 256;
create index  int_idxT6 on T6(O) attribute extent 256;
create index  smint_idxT6 on T6(P) attribute extent 256;
create index  lint_idxT6 on T6(Q) attribute extent 256;
create index  num_idxT6 on T6(R) attribute extent 256;
create index  dem_idxT6 on T6(S) attribute extent 256;
create index  flo_idxT6 on T6(U) attribute extent 256;
create index   rel_idxT6 on T6(V) attribute extent 256;
create index  dou_idxT6 on T6(W) attribute extent 256;
create unique index   tms_idxT6 on T6(X) attribute extent 256;
create index  intv_idxT6 on T6(Y) attribute extent 256;
create index   char_idxT6 on T6(Z) attribute extent 256;

Create  table T7 (R Numeric(9,3),AA Time,  FOREIGN KEY(R,AA) REFERENCES T5
                  )no partitions;

Create  table T8(AA Time, FOREIGN KEY(AA) REFERENCES T6)
                        attribute extent 256 no partitions;

Create  table T9(M numeric(9,3), FOREIGN KEY(M) REFERENCES T4  
                )no partitions;

insert into T1 values(2, 1);
insert into T1 values(4, 2);
insert into T1 values(6, 3);
insert into T1 values(8,4);
insert into T1 values(10,5);
insert into T1 values(12, -32768);
insert into  T1(A) values (11);
insert into  T1(A) values (13);
insert into T1 (a,B) values (14, 10);

insert into T3 values(10, -32768 , -923720368547588, -99999.999);

insert into T4 values(2, 1,1,1,0);
insert into T4 values(4, 2,2,2,0);
insert into T4 values(6, 3,3,3,0);
insert into T4 values(8, 4,4,4,0);
insert into T4 values(10, 5,5,5,0);
insert into T4 values(16, 7,7,7,0);
insert into T4 values(12, -32768 , -923720368547588, -99999.999, -999999.99999999);
insert into  T4(J,K,L,M) values (14, 6,6,6);
insert into  T4(J,M) values (10, 16);

insert into T5 values(2,1,1,1,0,  '1999-12-31', 1,1,1, TIMESTAMP'1999-01-01 00:00:00.000000', INTERVAL '99-02'YEAR TO MONTH, '1',TIME '00:00:04');
insert into T5 values(4, 2,1,2,0,  '1991-12-31', 1,1,1, TIMESTAMP '1997-01-01 00:00:00.000000', INTERVAL '99-02'YEAR TO MONTH, '2', TIME '00:00:03');
insert into T5 values(6, 3,1,3,0,  '1992-12-31', 1,1,1, TIMESTAMP'1998-01-01 00:00:00.000000',INTERVAL '99-02'YEAR TO MONTH, '2',  TIME '00:00:02');
insert into T5 values(7, -32768 , -923720368547588, -9999.990, -999999.99999999,  '1993-12-31', 1,1,1, TIMESTAMP '1998-01-01 00:00:59.000000', INTERVAL '99-02'YEAR TO MONTH, '2',  TIME '00:00:00');
insert into  T5(P,R,T,AA) values (7, 7,'',TIME '00:00:01');
insert into T5 values(8, -32768,  -923720368547588, -99999.900, -999999.99999000, '2006-06-15', 7.000000000001, -2.2250738585072014, -1.17549435e-38, TIMESTAMP '2006-06-23 17:56:59.300439', INTERVAL '06-06'YEAR TO MONTH, '1', TIME '17:05:45');
insert into T5 values(9, 32767,  923720368547587,   999998.999, 9999999.999999999,  '2005-07-24', 6.000001, 4509.000000001, 3.40282347e+38, TIMESTAMP '2005-12-24 09:21:11.234039', INTERVAL '06-07'YEAR TO MONTH, '12', TIME '07:35:54');
insert into T5 values(10,  7892,  9809876586,  23990.78, 8769.1200454,  '2000-04-12', 11897.9998877656,  898889.00000997, 555.23,   TIMESTAMP '1999-01-01 02:11:33.100439', INTERVAL '06-11' YEAR TO MONTH, '123', TIME '00:21:30');

insert into T6 values(2,1,1,1,0,  '1999-12-31', 1,1,1, TIMESTAMP'1999-01-01 00:00:00.000000', INTERVAL '99-02'YEAR TO MONTH, '1',TIME '00:00:04');
insert into T6 values(4, 2,1,2,0,  '1990-12-31', 1,1,1, TIMESTAMP '1997-01-01 00:00:00.000000', INTERVAL '99-02'YEAR TO MONTH, '2', TIME '00:00:03');
insert into T6 values(6, 3,1,3,0,  '1991-12-31', 1,1,1, TIMESTAMP'1998-01-01 00:00:00.000000',INTERVAL '99-02'YEAR TO MONTH, '2', TIME '00:00:02');
insert into T6 values(7, -32768 , -923720368547588, -99999.999, -999999.99999999,  '1992-12-31', 1,1,1, TIMESTAMP '1998-01-01 00:00:59.000000', INTERVAL '99-02'YEAR TO MONTH, '2',  TIME '00:00:00');
insert into  T6(P,R,AA) values (7, 7,TIME '00:00:01');
insert into T6 values(8, -32768,  -923720368547588, -99999.900, -999999.99999000, '2006-06-15', 7.000000000001, -2.2250738585072014, -1.17549435e-38, TIMESTAMP '2006-06-23 17:56:59.300439', INTERVAL '06-06'YEAR TO MONTH, '1', TIME '17:05:45');
insert into T6 values(9, 32767,  923720368547587,   999998.999, 9999999.999999999,  '2005-07-24', 6.000001, 4509.000000001, 3.40282347e+38, TIMESTAMP '2005-12-24 09:21:11.234039', INTERVAL '06-07'YEAR TO MONTH, '12', TIME '07:35:54');
insert into T6 values(10,  7892,  9809876586,  23990.78, 8769.1200454,  '2000-04-12', 11897.9998877656,  898889.00000997, 555.23,   TIMESTAMP '1999-01-01 02:11:33.100439', INTERVAL '06-11' YEAR TO MONTH, '123', TIME '00:21:30');

insert into T7 values(7,TIME '00:00:01');
insert into T7 values(null,null);
insert into T7 values(1,TIME '00:00:04');
insert into T7 values(23990.78,TIME '00:21:30'); 

insert into T8 values(TIME '00:21:30');
insert into T8 values(null);
insert into T8 values(TIME '07:35:54');
insert into T8 values(TIME '00:00:02');

insert into T9 values(1);
insert into T9 values(null);
insert into T9 values(2);
insert into T9 values(3);

update T1 set a = 99999 where a = 2; 

-- expect 99999,1
select * from t1 where a = 99999;

PREPARE XX FROM update T1 set a = 12 where a =11;
-- expect ERROR[8102] operation prevented by unique constraint
execute XX;

PREPARE XX FROM  update T2 set D = 11;
-- expect 0 rows updated
execute XX;

-- expect 1 rows updated
update T3 set H = 11 where F =10;

-- expect 0 rows selected
select * from t3 where h = 1166;

PREPARE XX FROM update T1 set a = 21, b= 13;
-- expected ERROR[8102] operation prevented by unique constraint
execute XX;

drop table T1; 
drop table T2; 
drop table T3; 
drop table T7; 
drop table T8; 
drop table T9; 
drop table T4; 
drop table T5; 
drop table T6;

Create table  T1(A int  not null not droppable primary key, 
                           B  smallint default null) 
                   attribute extent 256;

Create table T2(C int default null, 
                            D smallint not null not droppable primary key,
                            E largeint default null) 
                            attribute extent 256;

Create  table T3(F int not null not droppable ,  
                           G  smallint not null not droppable , 
                           H largeint not null not droppable , 
                            I numeric(9,3) default null,
                            primary key (F,G,H) ) 
                            attribute extent 256;

Create  table T4          (J int default null,  
                           K smallint not null not droppable, 
                            L largeint not null not droppable,  
                             M numeric(9,3) not null not droppable,  
                             N decimal(18,9) default null,
                             primary key (K,L,M) )
                             --hash partition by (K,L,M) 
                             attribute extent 256;

Create  table T5       (O int default null,  
                  	P smallint default null, 
			Q  largeint default null, 
			R numeric(9,3) not null not droppable ,  
			S decimal(18,9) default null, 
			T char(20) default null, 
			U float(52) default null, 
			V real default null, 
			W double precision default null, 
			X timestamp default null, 
			Y interval year to month default null ,
			Z char (12) default null, 
			AA time not null not droppable, primary key (R,AA))
                        attribute extent 256;

Create  table T6       (O int default null,  
                  	 P smallint default null, 
			Q  largeint default null, 
			R numeric(9,3) not null ,  
			S decimal(18,9) default null, 
			T char(20) default null, 
			U float(52) default null, 
			V real default null, 
			W double precision default null, 
			X timestamp default null, 
			Y interval year to month default null ,
			Z char (12) default null, 
			AA time not null primary key droppable)
                        attribute extent 256;

Create  table T7 (R Numeric(9,3),AA Time,  FOREIGN KEY(R,AA) REFERENCES T5
                  );

Create  table T8(AA Time, FOREIGN KEY(AA) REFERENCES T6)
                        attribute extent 256;

Create  table T9(K smallint,L largeint,M numeric(9,3), FOREIGN KEY(K,L,M) REFERENCES T4  
                );

create index smint_idx on T1(B) attribute extent 256;
create index lint_idx on T2(E) attribute extent 256;
create index int_idx on T2(C) attribute extent 256;
create index num_idx on T3(I) attribute extent 256;
create index  dem_idxT4 on T4(N) attribute extent 256;
create index  int_idxT4 on T4(J) attribute extent 256;
create unique index dat_idxT5 on  T5(T) attribute extent 256;
create index  int_idxT5 on T5(O) attribute extent 256;
create index  smint_idxT5 on T5(P) attribute extent 256;
create index  lint_idxT5 on T5(Q) attribute extent 256;
create index  num_idxT5 on T5(R) attribute extent 256;
create index  dem_idxT5 on T5(S) attribute extent 256;
create index  flo_idxT5 on T5(U) attribute extent 256;
create index   rel_idxT5 on T5(V) attribute extent 256;
create index  dou_idxT5 on T5(W) attribute extent 256;
create index   tms_idxT5 on T5(X) attribute extent 256;
create index  intv_idxT5 on T5(Y) attribute extent 256;
create index   char_idxT5 on T5(Z) attribute extent 256;
create unique index  tme_idxT5 on T5(AA) attribute extent 256;
create unique index dat_idxT6 on  T6(T) attribute extent 256;
create index  int_idxT6 on T6(O) attribute extent 256;
create index  smint_idxT6 on T6(P) attribute extent 256;
create index  lint_idxT6 on T6(Q) attribute extent 256;
create index  num_idxT6 on T6(R) attribute extent 256;
create index  dem_idxT6 on T6(S) attribute extent 256;
create index  flo_idxT6 on T6(U) attribute extent 256;
create index   rel_idxT6 on T6(V) attribute extent 256;
create index  dou_idxT6 on T6(W) attribute extent 256;
create index   tms_idxT6 on T6(X) attribute extent 256;
create index  intv_idxT6 on T6(Y) attribute extent 256;
create index   char_idxT6 on T6(Z) attribute extent 256;

insert into T1 values(2, 1);
insert into T1 values(4, 2);
insert into T1 values(6, 3);
insert into T1 values(8,4);
insert into T1 values(10,5);
insert into T1 values(12, -32768);
insert into  T1(A) values (11);
insert into  T1(A) values (13);

insert into T3 values(10, -32768 , -923720368547588, -99999.999);

insert into T4 values(2, 1,1,1,0);
insert into T4 values(4, 2,2,2,0);
insert into T4 values(6, 3,3,3,0);
insert into T4 values(8, 4,4,4,0);
insert into T4 values(10, 5,5,5,0);
insert into T4 values(12, -32768 , -923720368547588, -99999.999, -999999.99999999);
insert into  T4(J,K,L,M) values (14, 6,6,6);

insert into T5 values(2,1,1,1,0,  '1999-12-31', 1,1,1, TIMESTAMP'1999-01-01 00:00:00.000000', INTERVAL '99-02'YEAR TO MONTH, '1',TIME '00:00:04');
insert into T5 values(4, 2,1,2,0,  '1990-12-31', 1,1,1, TIMESTAMP '1997-01-01 00:00:00.000000', INTERVAL '99-02'YEAR TO MONTH, '2', TIME '00:00:03');
insert into T5 values(6, 3,1,3,0,  '1991-12-31', 1,1,1, TIMESTAMP'1998-01-01 00:00:00.000000',INTERVAL '99-02'YEAR TO MONTH, '2',  TIME '00:00:02');
insert into T5 values(7, -32768 , -923720368547588, -99999.999, -999999.99999999,  '1993-12-31', 1,1,1, TIMESTAMP '1998-01-01 00:00:00.000000', INTERVAL '99-02'YEAR TO MONTH, '2',  TIME '00:00:00');
insert into  T5(P,R,T,AA) values (7, 7,'',TIME '00:00:01');
insert into T5 values(8, -32767,  -923720368547588, -99999.900, -999999.99999000, '2006-06-15', 7.000000000001, -2.2250738585072014, -1.17549435e-38, TIMESTAMP '2006-06-23 17:56:59.300439', INTERVAL '06-06'YEAR TO MONTH, '1', TIME '17:05:45');
insert into T5 values(9, 32767,  923720368547587,   999998.999, 9999999.999999999,  '2005-07-24', 6.000001, 4509.000000001, 3.40282347e+38, TIMESTAMP '2005-12-24 09:21:11.234039', INTERVAL '06-07'YEAR TO MONTH, '12', TIME '07:35:54');
insert into T5 values(10,  7892,  9809876586,  23990.78, 8769.1200454,  '2000-04-12', 11897.9998877656,  898889.00000997, 555.23,   TIMESTAMP '1999-01-01 02:11:33.100439', INTERVAL '06-11' YEAR TO MONTH, '123', TIME '00:21:30');

insert into T6 values(2,1,1,1,0,  '1999-12-31', 1,1,1, TIMESTAMP'1999-01-01 00:00:00.000000', INTERVAL '99-02'YEAR TO MONTH, '1',TIME '00:00:04');
insert into T6 values(4, 2,1,2,0,  '1990-12-31', 1,1,1, TIMESTAMP '1997-01-01 00:00:00.000000', INTERVAL '99-02'YEAR TO MONTH, '2', TIME '00:00:03');
insert into T6 values(6, 3,1,3,0,  '1991-12-31', 1,1,1, TIMESTAMP'1998-01-01 00:00:00.000000',INTERVAL '99-02'YEAR TO MONTH, '2',  TIME '00:00:02');
insert into T6 values(7, -32768 , -923720368547588, -99999.999, -999999.99999999,  '1993-12-31', 1,1,1, TIMESTAMP '1998-01-01 00:00:00.000000', INTERVAL '99-02'YEAR TO MONTH, '2',  TIME '00:00:00');
insert into  T6(P,R,AA) values (7, 7,TIME '00:00:01');
insert into T6 values(8, -32768,  -923720368547588, -99999.900, -999999.99999000, '2006-06-15', 7.000000000001, -2.2250738585072014, -1.17549435e-38, TIMESTAMP '2006-06-23 17:56:59.300439', INTERVAL '06-06'YEAR TO MONTH, '1', TIME '17:05:45');
insert into T6 values(9, 32767,  923720368547587,   999998.999, 9999999.999999999,  '2005-07-24', 6.000001, 4509.000000001, 3.40282347e+38, TIMESTAMP '2005-12-24 09:21:11.234039', INTERVAL '06-07'YEAR TO MONTH, '12', TIME '07:35:54');
insert into T6 values(10,  7892,  9809876586,  23990.78, 8769.1200454,  '2000-04-12', 11897.9998877656,  898889.00000997, 555.23,   TIMESTAMP '1999-01-01 02:11:33.100439', INTERVAL '06-11' YEAR TO MONTH, '123', TIME '00:21:30');

insert into T7 values(-99999.900,TIME '17:05:45');
insert into T7 values(null,null);
insert into T7 values(999998.999,TIME '07:35:54');
insert into T7 values(23990.78,TIME '00:21:30'); 
insert into T7 values (7, TIME '00:00:01');

insert into T8 values(TIME '00:21:30');
insert into T8 values(null);
insert into T8 values(TIME '07:35:54');
insert into T8 values(TIME '00:00:02');

insert into T9 values(1,1,1);
insert into T9 values(null,null,null);
insert into T9 values(2,2,2);
insert into T9 values(3,3,3);

update T1 set a = 99999 where a = 2; 

-- expected 99999,1
select * from t1 where a = 99999;

PREPARE XX FROM   update T1 set a = 12 where a =11;
-- expected ERROR[8102] operation prevented by unique constraint
execute XX;

PREPARE XX FROM  update T2 set D = 11;
-- expected 0 rows updated
execute XX;

-- expected 1 rows updated
update T3 set H = 11 where F =10;

-- expected 0 rows selected
select * from t3 where h = 1166;

PREPARE XX FROM update T1 set a = 21, b= 13;
-- expected ERROR[8102] operation prevented by unique constraint
execute XX;

drop table T1; 
drop table T2; 
drop table T3; 
drop table T7; 
drop table T8; 
drop table T9;
drop table T4; 
drop table T5; 
drop table T6;

Create table  T1(A int not null not droppable primary key , 
                 B  smallint);

Create table T2(C int, 
                D smallint not null not droppable primary key,  
                E largeint);

Create  table T3(F int,  
                 G  smallint, 
                 H largeint not null not droppable primary key, 
                 I  numeric(9,3));

Create  table T4(J int,  
                 K smallint, 
                 L largeint ,  
                 M numeric(9,3) not null not droppable primary key,  
                 N decimal(18,9));

Create  table T5(O int,  
P smallint, 
Q  largeint, 
R numeric(9,3)not null not droppable,  
S decimal(18,9), 
T char(20), 
U float(52), 
V real, 
W double precision, 
X timestamp,
Y interval year to month ,
Z char (12), 
AA time not null not droppable, primary key(R,AA));

Create  table T6       (O int default null,  
                  	 P smallint default null, 
			Q  largeint default null, 
			R numeric(9,3) not null ,  
			S decimal(18,9) default null, 
			T char(20) default null, 
			U float(52) default null, 
			V real default null, 
			W double precision default null, 
			X timestamp default null, 
			Y interval year to month default null ,
			Z char (12) default null, 
			AA time not null primary key droppable)
                        attribute extent 256;

-- getting ERROR[1389] Object T5_694177485_1117 does not exist in Trafodion, 
-- ERROR[8838] Unable to receive reply from Compiler, possibly caused by 
-- internal errors when compiling SQL statements, processing DDL statements,
-- or executing the builtin stored procedures, ERROR[1029] Object 
-- TRAFODION.SCH_PKEY.T7_324948485_1117 could not be created., ERROR[1029] 
-- Object TRAFODION.SCH_PKEY.T7 could not be created. 
Create  table T7 (R Numeric(9,3),AA Time,  FOREIGN KEY(R,AA) REFERENCES T5
                  );

--Create  table T8(AA Time, FOREIGN KEY(AA) REFERENCES T6)
--                        attribute extent 256;

--Create  table T9(M numeric(9,3), FOREIGN KEY(M) REFERENCES T4  
--                );
